function IslamicFinderServer(fzami)
{
    this.basePrayerTimeURL="http://www.islamicfinder.org/prayerDetail.php?";
    this.baseCitiesUrl="http://www.islamicfinder.com/cityPrayer.php?";
    this.lastRequest = null;
    this.lastRequestDate = null;
    this.fzami = fzami;

    this.reloadPrayerTimes = reloadPrayerTimes;
    this.calculatePrayerTimeUrl = calculatePrayerTimeUrl;
    this.onLoadPrayerTimes = onLoadPrayerTimes;
    this.onErrorLoadingPrayerTimes = onErrorLoadingPrayerTimes;
    this.parsePrayerTimes = parsePrayerTimes;
   
    this.loadCitiesFor = loadCitiesFor;
    this.calculateCityListUrl = calculateCityListUrl;
    this.onLoadCities = onLoadCities;
    this.onErrorLoadingCities = onErrorLoadingCities;

    this.openMonthlyPrayerSchedule = openMonthlyPrayerSchedule;
    this.preferences = Components.classes["@mozilla.org/preferences-service;1"]
                                .getService(Components.interfaces.nsIPrefBranch);



    function reloadPrayerTimes() {
      var URL = null;
      try {
        URL = this.calculatePrayerTimeUrl();
      } catch(e) {
        this.lastRequest = null;
alert(e);
        this.fzami.showError('Error reading preferences');
	return;
      }
      if (this.lastRequest == URL)
      {
        var now = new Date();
        if (this.lastRequestDate != null
		&& this.lastRequestDate.getYear() == now.getYear()
		&& this.lastRequestDate.getMonth() == now.getMonth()
		&& this.lastRequestDate.getDay() == now.getDay())
        {
          this.fzami.rerender();
          return;
        }
      }
      this.lastRequest = URL;
      this.lastRequestDate = new Date();

      //setup request and send
      var module = this;
      var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
      request.open("GET", URL, true);
      request.onload = function() { module.onLoadPrayerTimes(this.responseText, this.status) };
      request.onerror = function() { module.onErrorLoadingPrayerTimes() };
      try {
        if (request.channel instanceof Components.interfaces.nsISupportsPriority)
          request.channel.priority = Components.interfaces.nsISupportsPriority.PRIORITY_HIGHEST;
      } catch(e) {};
      request.send(null);
    }


    function calculatePrayerTimeUrl() {
	var url = this.basePrayerTimeURL;

	var uscLocation = this.preferences.getIntPref("extensions.fzami.location.type");
	if (uscLocation == 0)
	{
		var zipcode = this.preferences.getCharPref("extensions.fzami.location.zipcode");
		url += "&country=usa&zipcode="+zipcode;	
	} else {
		var city = this.preferences.getCharPref("extensions.fzami.location.city");
//		var state = this.preferences.getCharPref("extensions.fzami.location.state");
		var country = this.preferences.getCharPref("extensions.fzami.location.country");
		url += "&country="+country+"&city="+city;
	}

	var prayerCalcMethod = this.preferences.getIntPref("extensions.fzami.prayercal.method");
	var asrmethod = this.preferences.getIntPref("extensions.fzami.prayercal.asrmethod");
	url += "&HanfiShafi="+asrmethod;
	url += "&pmethod="+prayerCalcMethod;
 	if (prayerCalcMethod == 6)
	{
		var fajrTwilight = this.preferences.getIntPref("extensions.fzami.prayercal.fajrangle");
		var dhuhrInterval = this.preferences.getIntPref("extensions.fzami.prayercal.zuhrdelay");
		var maghribInterval = this.preferences.getIntPref("extensions.fzami.prayercal.maghribdelay");
		var ishaTwilight = this.preferences.getIntPref("extensions.fzami.prayercal.ishaangle");

		url += "&prayerCustomize=1&fajrTwilight1="+fajrTwilight+"&ishaTwilight="+ishaTwilight+"&dhuhrInterval="+dhuhrInterval+"&maghribInterval="+maghribInterval;
	}

	return url;
    }

    function openMonthlyPrayerSchedule() {
      try {
        var url = this.calculatePrayerTimeUrl();
        openLink(url);
      } catch(e) {
        alert("Error reading fzami preferences.  Going directly to Islamicfinder.org");
        openLink("http://www.islamicfinder.org/");
      }
    }

    function onLoadPrayerTimes(aResponse, aStatus)
    { 
      if (!aResponse || aStatus > 200) {
        this.onErrorLoadingPrayerTimes("Error contacting Islamicfinder (status="+aStatus+").");
      } else {
        var prayertimes = this.parsePrayerTimes(aResponse);
        if (typeof(prayertimes) == "string")
        {
	  this.onErrorLoadingPrayerTimes(prayertimes);
        } else {
          this.fzami.setPrayerTimes(prayertimes);
        }
      }
    }

    function onErrorLoadingPrayerTimes(errorMsg)
    {
       this.lastRequest = null;
       this.lastRequestDate = null;
       if (typeof(errorMsg) == "undefined") errorMsg = "Error contacting Islamicfinder.";
       this.fzami.showError(errorMsg);
    }


    function parsePrayerTimes(response) {
	if (response.indexOf("www.islamicfinder.org") == -1)
	{
		return "Error contacting Islamicfinder.";
	}
	if (response.indexOf("Error#") != -1)
	{
		return "Error: Invalid preference settings.";
	}

	response = response.substring(response.indexOf("Sunrise</a>"));
	response = response.substring(response.indexOf("<TR"));
	response = response.substring(0, response.indexOf("</TR>")+5);

	response = response.substring(response.indexOf("center>")+7);
	var fajr = new Time(trim(response.substring(0, response.indexOf("</TD")-1)));
	response = response.substring(response.indexOf("center>")+7);
	var shuruk = new Time(trim(response.substring(0, response.indexOf("</TD")-1)));
	response = response.substring(response.indexOf("center>")+7);
	var zuhr = new Time(trim(response.substring(0, response.indexOf("</TD")-1)));
	response = response.substring(response.indexOf("center>")+7);
	var asr = new Time(trim(response.substring(0, response.indexOf("</TD")-1)));
	response = response.substring(response.indexOf("center>")+7);
	var maghrib = new Time(trim(response.substring(0, response.indexOf("</TD")-1)));
	response = response.substring(response.indexOf("center>")+7);
	var isha = new Time(trim(response.substring(0, response.indexOf("</TD")-1)));

	var inPM = zuhr.hour < fajr.hour;
        if (inPM) zuhr.hour += 12; else inPM = asr.hour < zuhr.hour;
        if (inPM) asr.hour += 12; else inPM = maghrib.hour < asr.hour;
        if (inPM) maghrib.hour += 12; else inPM = isha.hour < maghrib.hour;
        if (inPM) isha.hour += 12;

	var prayertimes = new Array;
	prayertimes['fajr'] = fajr;
	prayertimes['shuruk'] = shuruk;
	prayertimes['zuhr'] = zuhr;
	prayertimes['asr'] = asr;
	prayertimes['maghrib'] = maghrib;
	prayertimes['isha'] = isha;

	return prayertimes;
  }

  function loadCitiesFor(countryName, callback)
  {
      var URL = null;
      try {
        URL = this.calculateCityListUrl(countryName);
      } catch(e) {
        callback([{value:"", label:"Error reading city list for "+countryName}]);
	return;
      }

      //setup request and send
      var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
      request.open("GET", URL);
      var module = this;
      request.onload = function() { module.onLoadCities(callback, this.responseText, this.status); }
      request.onerror = function() { module.onErrorLoadingCities(callback); }
      try {
        if (request.channel instanceof Components.interfaces.nsISupportsPriority)
          request.channel.priority = Components.interfaces.nsISupportsPriority.PRIORITY_HIGHEST;
      } catch(e) {};
      request.send(null);
   }

   function calculateCityListUrl(countryName)
   {
      return this.baseCitiesUrl+"country="+countryName;
   }

       function onLoadCities(callback, response, status)
       {
            var cities = new Array();
            if (!response || status > 200) {
               cities[0] = { value:"", label: "Error contacting Islamicfinder (status="+status+")." }
            } else if (response.indexOf("www.islamicfinder.org") == -1)
	    {
               cities[0] = { value:"", label: "Error contacting Islamicfinder." }
	    } else {

	  	response = response.substring(response.indexOf("Main Cities"));
		response = response.substring(response.indexOf("<br>")+4);
		response = response.substring(0, response.indexOf("<br>"));
		var i = 0;
		while (response.indexOf("</a>") > -1) {
			response = response.substring(response.indexOf("\">")+2);
			var endIndex = response.indexOf("</a>");
			var cityName = response.substring(0, endIndex);
			cities[i++] = { value: cityName, label: cityName }
			response = response.substring(endIndex+4);
		}
            }

            callback(cities);
       }


       function onErrorLoadingCities(callback)
       {
            var cities = new Array();
            cities[0] = { value:"", label: "Error contacting Islamicfinder." }

            callback(cities);
       }
}